#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include "usbdrv.h"

#define RQ_IR 1
#define RQ_SET_RELAY 2


usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
    	usbRequest_t *rq = (void *)data;
	static uchar ir_value;

	if(rq->bRequest == RQ_IR)
	{
		ir_value = (PINC & (1 << PC1));
		usbMsgPtr = (uchar*) &ir_value;
		return sizeof(uchar);
	}
	if(rq->bRequest == RQ_SET_RELAY)
	{
		uint8_t relay_val = rq->wValue.bytes[0];

        	if (relay_val){
				PORTC = 0b00000100;
				PORTD = 0b00001000;
		}
        	else{
				PORTC = 0b00000000;
				PORTD = 0b00000000;
		}
		return 0;
	}
	return 0;
}

int main(void)
{
	PORTC = 0b00000000;
	DDRD = 0b00001000;
	DDRC = (~(1 << PC1))|(1<<PC3);
	PORTC = 1<<PC1;
	usbInit();
	usbDeviceDisconnect();
	_delay_ms(300);
	usbDeviceConnect();
	sei();
	while(1)
	{
		usbPoll();
	}
	return 0;
}
